/* 
 * File:   Tableur.cpp
 * Author: Belhadj&&Jardak
 * 
 * Created on 14 juin 2010, 16:52
 */

#include "Tableur.h"
#include <iostream>
#include <sstream>


Tableur::Tableur() {
    Tete=NULL;
    Lactive=0;
    Cactive=0;
}

Tableur::Tableur(const Tableur& orig)
{
    Tete = NULL;
    Cellule * courant = orig.Tete;
    while (courant)
    {
       edit(courant->L,courant->C,courant->Formule);
       Cellule * courant2 = courant;
       while (courant2->Lsuivant)
       {
           courant2=courant2->Lsuivant;
           edit(courant2->L,courant2->C,courant2->Formule);

       }
       courant = courant->Lsuivant;
    }
}

Tableur::~Tableur() {
    Cellule * p=Tete;
    Cellule * p1;
    Cellule * p2;
    if (p)
        p1 = p->Csuivant;
    else p1=NULL;
    while (p1)
    {
        if (p)
            p2 = p->Csuivant;
        else p2=NULL;
        while (p2)
        {
            p = p2;
            p2 = p2->Lsuivant;
            delete p;
        }
        delete p;
        p = p1;
        p1 = p1->Csuivant;
    }
    delete p;
}



//affiche tous les formules d'un tableur
void Tableur::afficheF()
{
    Cellule * courant=Tete;
    Cellule* courant2;
    if(courant==NULL)
    {
        cout<<"Tableur vide"<<endl;
    }
    else
    {
        while (courant)
        {
            cout<<"L= "<<(courant->L)<<"    C= "<<(courant->C)<<"   Formule= "<<(courant->Formule)<<"\t";
            courant2=courant;
            while(courant2->Lsuivant)
            {
                courant2=courant2->Lsuivant;
                cout<<"L= "<<(courant2->L)<<"   C="<<(courant2->C)<<"   Formule="<<(courant2->Formule)<<"\t";
            }
            cout<<endl;
            courant=courant->Csuivant;
        }
    }
}


//affiche les contenus de toutes les cellules d'un tableur
void Tableur::afficheC()
{
    Cellule * courant=Tete;
    Cellule* courant2;
    if(courant==NULL)
    {
        cout<<"Tableur vide"<<endl;
    }
    else
    {
        while (courant)
        {
            cout<<"L= "<<(courant->L)<<"    C= "<<(courant->C)<<"    Contenu= "<<(eval(courant->L,courant->C))<<"\t";
            courant2=courant;
            while(courant2->Lsuivant)
            {
                courant2=courant2->Lsuivant;
                cout<<"L= "<<(courant2->L)<<"   C= "<<(courant2->C)<<"   Contenu= "<<(eval(courant2->L,courant2->C))<<"\t";
            }
            cout<<endl;
            courant=courant->Csuivant;
        }
    }
}

//recherche dans une colonne
//p==next
//retourne un pointeur sur precedent
Cellule * Tableur::rechercheC (int c,Cellule *& p)
{
    p = Tete;
    Cellule * p1 = NULL;
    if (p)
    {
        while (p != NULL && c > p->C)
        {
            p1=p;
            p=p->Csuivant;
        }
    }
    return p1;
}

//recherche dans une ligne
//p==next
//retourne un pointeur sur precedent
//cell la tete de la colonne
Cellule * Tableur::rechercheL (int l,Cellule * cell, Cellule *& p)
{
    p = cell;
    Cellule * p1 = NULL;
    while (p != NULL && l > p->L)
    {
        p1=p;
        p=p->Lsuivant;
    }
    return p1;
}


//si une cellule est appele dans la formule d'une autre cellule
bool Tableur::exist(string cel,string ref)
{
    int a=0,b=0;
    string ref1;
    
    if(ref=="")
    {
        return false;
    }
    while(b!=(-1))
    {
        b=rech(ref,ref1,a);
        if (b!=(-1))
        {
            if ((cel==ref)||(cel==ref1)||(exist(cel,ref1)))
            {
                return true;
            }
            a=b+1;
        }
    }
    return false;
}


//a partir de l et c(string cell) elle rechercher la formule f
//et a partir de la position deb elle commence a chercher
//une reference vers une autre cellule et la retourne dans ref
//retourne la position de ref si elle existe sinon elle retourne -1
int Tableur::rech(string cel,string& ref,int deb)
{
    int i=deb,l=0,c=0,j=0;
    ref.erase();
    string ch,L,C;

    int k;
    if (cel[1]=='$')
        k=2;
    else
        k=1;
    while(cel[k]!=',')
    {
        L=L+cel[k];
        k=k+1;
    }
    istringstream s1(L);
    s1>>l;
    k=k+1;
    while(cel[k]!=']')
    {
        C=C+cel[k];
        k=k+1;
    }
    istringstream s2(C);
    s2>>c;
    
    if (l>0&&c>0)
    {
        ch=rechercheF(l,c);
        if(ch!="")
        {
            if (deb>ch.size()-1)
            {
                return -1;
            }
            else{
            while((ch[i]!='\0')&&(ch[i]!='['))
            {
                i=i+1;
            }
            j=i;
            if(ch[j]=='[')
            {
                ref=ref+ch[j];
                j=j+1;
                if(ch[j]!='$')
                {
                    ref=ref+ch[j];
                    j=j+1;
                }
                else if (ch[j]!='\0')
                {
                    j=j+1;
                }
                while((ch[j]!=']')&&(ch[j]!='\0'))
                {
                    ref=ref+ch[j];
                    j++;
                }
                    ref=ref+ch[j];
                    return j;
            }}
        }
        else
        {
            return (-1);
        }
    }
    else
    {
        throw "~~ Error: Reference a une Cellule erronee [l>0,c>0]";
    }

}


//la methode edit qui cree une cellule
// et si la formule fait appel a d'autre cellule elle ne les cree pas
//mais elle verifie a ce qu'il n'y a pas de boucle
void Tableur::edit(int l, int c, string formule)
{
    Cellule * next;
    Cellule * p = rechercheC(c,next);

    int n;
    for(n=0;n<formule.size();n++)
    {
        int a;
        a=formule[n];
        if(!(((a>39)&&(a<58))||(a==93)||(a==91)||(a==36)))
            throw "~~ Error: Formule erronee";
    }

    int a=formule.find("[",0),b=formule.find("]",0);
    string cel;
    stringstream s;
    s<<"["<<l<<","<<c<<']';
    cel=s.str();
    while(1)
    {       
        if((a!=(-1))&&(a<b))
        {
            string temp;
            if(formule[a+1]!='$')
            {
            temp=formule.substr(a,b-a+1);
            }
            else
            {
                temp="["+formule.substr(a+2,b-a-1);
            }

            bool res=true;
            if(1)
            {
                int i=1,c=0,k=0;
                while(i<(temp.length()-1))
                {
                    c=temp[i];   //l'ascii du caractere
                    if(((c>47)&&(c<58))||(c==44))
                    {
                        i=i+1;
                        if (c==44)
                            k++;
                    }
                    else
                    {
                        res=false;
                        break;
                    }
                }
                if(res)
                {
                    if((temp[0]=='[')&&(temp[(temp.size()-1)]==']')&&(temp[1]!=',')&&(temp[temp.size()-2]!=',')&&(k==1))
                    {
                        
                        res=true;
                    }
                    else
                    {
                        res=false;
                    }
                }
            }
            if(res)
            {
                if (exist(cel,temp))
                {
                    throw "~~ Error: Reference circulaire";
                }
            }
            else
            {
                throw "~~ Error: formule erronnee";
            }
            
        }
        else if((a>b)||((a==-1)&&(b!=-1)))
        {
            throw "~~ Error: formule erronnee";
        }
        else
        {
            break;
        }
        a=formule.find("[",a+1);
        b=formule.find("]",b+1);
    }

    if (p)
    {
        if (!next)
        {
            Cellule * n = new Cellule(l,c,formule);
            p->Csuivant=n;
            n->Csuivant=next;
            n->Lsuivant=NULL;
        }
        else if (next->C != c)
            {
                Cellule * n = new Cellule(l,c,formule);
                p->Csuivant=n;
                n->Csuivant=next;
                n->Lsuivant=NULL;
            }
        else
        {
            Cellule * next2;
            Cellule * p2=rechercheL(l,next,next2);
            if (p2)
            {
                if (!next2)
                {
                    Cellule * n = new Cellule(l,c,formule);
                    p2->Lsuivant=n;
                    n->Lsuivant=next2;
                    n->Csuivant=NULL;
                }
                else if (next->L != l)
                {
                    Cellule * n = new Cellule(l,c,formule);
                    p2->Lsuivant=n;
                    n->Lsuivant=next2;
                    n->Csuivant=NULL;
                }
                else
                    next->Formule=formule;
            }
            else if (next2->L != l)
            {
                Cellule * n = new Cellule(l,c,formule);
                p->Csuivant=n;
                n->Lsuivant=next;
                n->Csuivant=next->Csuivant;
                next->Csuivant=NULL;
            }
            else
                next->Formule=formule;
        }
    }
    else if (next)
    {
        if (next->C != c)
        {
            Cellule * n = new Cellule(l,c,formule);
            Tete=n;
            n->Csuivant=next;
            n->Lsuivant=NULL;
        }
        else
        {
            Cellule * next2;
            Cellule * p2=rechercheL(l,next,next2);
            if (p2)
            {
                if (!next2)
                {
                    Cellule * n = new Cellule(l,c,formule);
                    p2->Lsuivant=n;
                    n->Lsuivant=next2;
                    n->Csuivant=NULL;
                }
                else if (next->L != l)
                {
                    Cellule * n = new Cellule(l,c,formule);
                    p2->Lsuivant=n;
                    n->Lsuivant=next2;
                    n->Csuivant=NULL;
                }
                else
                    next->Formule=formule;
            }
            else if (next2->L != l)
            {
                Cellule * n = new Cellule(l,c,formule);
                Tete=n;
                n->Lsuivant=next;
                n->Csuivant=next->Csuivant;
                next->Csuivant=NULL;
            }
            else
                next->Formule=formule;
        }
    }
    else
    {
        Cellule * n = new Cellule(l,c,formule);
        n->Csuivant=NULL;
        n->Lsuivant=NULL;
        Tete=n;
    }
}


//rechercher la formule de la cellule donnee par l et c
//si elle n'existe pas elle retourne 0
string Tableur::rechercheF(int l, int c)
{
    Cellule * p = Tete;
    bool b=false;
    while (p && !b)
    {
        if (p->C==c)
            b=true;
        else
            p=p->Csuivant;
    }
    if (p && b)
    {
        b=false;
        while (p && !b)
        {
            if (p->L==l)
                b=true;
            else
                p=p->Lsuivant;
        }
        if (p)
            return p->Formule;
        else
            return "";
    }
    else return "";
}

//surcharge de l'operateur =
Tableur& Tableur::operator= (const Tableur & orig)
{
    Tableur temp(orig);
    swap(temp.Tete, this->Tete);
    return *this;
}

/*effectue les operations de multiplication et de division
 * ch:formule ne contenant que les operatreurs * et /
 * en sortie: le resultat
 */

float Tableur::mult_div (string ch)
{
    string temp="",op="";
    int i=0;
    float a=0,b=0;
    while ((ch[i]!='*')&&(ch[i]!='/')&&(ch[i]!='\0'))
    {
        temp=temp+ch[i];
        i=i+1;
    }
    if (temp[0]=='[')
    {
        string L,C;
        int l,c,k=1;
        while(temp[k]!=',')
        {
            L=L+temp[k];
            k=k+1;
        }
        istringstream s1(L);
        s1>>l;
        k=k+1;
        while(temp[k]!=']')
        {
            C=C+temp[k];
            k=k+1;
        }
        istringstream s2(C);
        s2>>c;
        a=eval(l,c);
    }
    else
    {
        if (temp[0]=='{')
        {
            temp=temp.substr(1,temp.size()-2);
            istringstream s(temp);
            s>>a;
            a=-a;
        }
        else
        {
            istringstream s(temp);
            s>>a;
        }
    }
    if (ch[i]!='\0')
    {
        op=ch[i];
        i=i+1;
    }
    while(ch[i]!='\0')
    {
        temp.erase();
        while ((ch[i]!='/')&&(ch[i]!='*')&&(ch[i]!='\0'))
        {
            temp=temp+ch[i];
            i=i+1;
        }
        if (temp[0]=='[')
        {
            string L,C;
            int l,c,k=1;
            while(temp[k]!=',')
            {
                L=L+temp[k];
                k=k+1;
            }
            istringstream s1(L);
            s1>>l;
            k=k+1;
            while(temp[k]!=']')
            {
                C=C+temp[k];
                k=k+1;
            }
            istringstream s2(C);
            s2>>c;
            b=eval(l,c);
        }
        else
        {
            if (temp[0]=='{')
            {
                temp=temp.substr(1,temp.size()-2);
                istringstream s(temp);
                s>>b;
                b=-b;
            }
            else
            {
                istringstream s(temp);
                s>>b;
            }
        }
        if (op[0]=='*')
        {
            a=a*b;
        }
        else
        {
            if (op[0]=='/')
            {
                if (b!=0)
                {
                    a=a/b;
                }
                else
                {
                    throw "~~ Error: Division par zero";
                }

            }
        }
        op=ch[i];
        i=i+1;
    }
    return a;
}

/*effectue les operations d'addition et de soustraction
 * ch:formule ne contenant que les operatreurs + et -
 * res:le resultat de la formule
 * en sortie: 1 si erreur,0 sinon
 * rn utilisant les interruption on a plus besoin de voir
 * s'il y en a une erreur ou pas puisque des qu'il y a une erreur
 * le programme sera interrompu
 */
float Tableur::add_min(string ch)
{
    string temp="",op="";
    int i=0;
    float a=0,b=0;

    while ((ch[i]!='+')&&(ch[i]!='-')&&(ch[i]!='\0'))
    {
        temp=temp+ch[i];
        i=i+1;
    }
    if (ch[i]!='\0')
    {
        op=ch[i];
        i=i+1;
    }
    a=mult_div(temp);
    while (ch[i]!='\0')
    {
        temp.erase();
        while ((ch[i]!='+')&&(ch[i]!='-')&&(ch[i]!='\0'))
        {
            temp=temp+ch[i];
            i=i+1;
        }
        b=mult_div(temp);
        if(op[0]=='+')
        {
            a=a+b;
        }
        else
        {
            if(op[0]=='-')
            {
                a=a-b;
            }
        }
        op=ch[i];
        i=i+1;
    }
    return a;
}

/*Supprime toute parenthese dans la formule
 *en calculant ce qu'il y a dedans*/
string Tableur::parenthese(string ch)
{
    string temp1="",temp2="",temp3="",temp="";
    int i=0,j=(-1),k=0,test;
    float res;

    while ((ch[i]!=')')&&(ch[i]!='\0'))
    {
        if (ch[i]=='(')
        {
            j=i;
        }
        i=i+1;
    }

    //si il y une parenthese fermante
    if(ch[i]==')')
    {
        //dans le cas ou on a (-5)*2 on le rend {5}
        //et quand on a {} on le rend negatif dans la fonction mult_div
        if (ch[j+1]=='-')
        {
            temp1=ch.substr(0,j);
            temp2=ch.substr(j+2,i-j-2);
            temp3=ch.substr(i+1,(ch.size()-i-1));
            temp=temp1+"{"+temp2+"}"+temp3;
            temp=parenthese(temp);
            return temp;
        }
        else
        {
            //dans le cas ou on a (expression)
            //il suffit de supprimer les parentheses
            if((i==(ch.length()-1))&&(j==0))
            {
                return ch.substr(1,(ch.size()-2));
            }
            else
            {
                //si il y une parenthse fermante mais pas de parenthese ouvrante
                if(j==(-1))
                {
                    throw "~~ Error: Parenthese fermante et pas de parenthese ouvrante";
                }
                //si on a une parenthese ouvrante et fermante
                //n'importe ou dans l'expression
                else
                {
                    temp1=ch.substr(0,j);
                    temp2=ch.substr(j+1,i-j-1);
                    temp3=ch.substr(i+1,(ch.size()-i-1));
                    res=add_min(temp2);
                    stringstream ss;
                    if(res>=0)
                    {
                        ss<<res;
                    }
                    else
                    {
                        res=-res;
                        ss<<"{"<<res<<"}";
                    }
                    temp2=ss.str();
                    temp=temp1+temp2+temp3;
                    temp=parenthese(temp);
                    return temp;
                }
            }
        }
    }
    else
        //s'il n'y a pas de parenthese fermante;
    {
        //si la parenthese ouvrante est au milieu de l'expression
        if(j>0)
        {
            temp1=ch.substr(0,j);
            temp2=ch.substr(j+1,(ch.size()-j-1));
            res=add_min(temp2);
            stringstream ss;
            if(res>=0)
            {
                ss<<res;
            }
            else
            {
                res=-res;
                ss<<"{"<<res<<"}";
            }
            temp2=ss.str();
            temp=temp1+temp2;
            temp=parenthese(temp);
            return temp;
        }
        //si la parenthese ouvrante est en debut d'expression
        else if (j==(0))
        {
            return ch.substr(1,(ch.size()-1));
        }
        //s'il n'y pas de parenthese ouvrante;
        else if (j==(-1))
        {
            return ch;
        }

    }

}

//evaluer la formule de la cellule donnee par l et c
float Tableur::eval(int l,int c)
{
    string ch="",temp="";
    float a;
    int b,i;
    ch=rechercheF(l,c);
    for(i=0;i<ch.size();i++)
    {
        if (ch[i]!='$')
        {
            temp=temp+ch[i];
        }
    }
    ch=temp;
    temp.erase();
    ch=parenthese(ch);
    return add_min(ch);
}


/*Copie la formule de la cellule source donnee par ls et cs
 dans la cellule destination donnee par ld et cd*/
void Tableur::copy(int ls,int cs,int ld,int cd)
{
    int i=0,ll=0,cc=0;
    string l="",c="";
    string ch="",temp="";
    ch=rechercheF(ls,cs);
    while(ch[i]!='\0')
    {
        if (ch[i]=='[')
        {
            temp=temp+ch[i];
            i=i+1;
            if(ch[i]=='$')
            {
                while(ch[i]!=']')
                {
                    temp=temp+ch[i];
                    i=i+1;
                }
                temp=temp+ch[i];
            }
            else
            {
                while(ch[i]!=',')
                {
                    l=l+ch[i];
                    i=i+1;
                }
                i=i+1;
                while(ch[i]!=']')
                {
                    c=c+ch[i];
                    i=i+1;
                }

                istringstream s1(l);
                istringstream s2(c);
                s1>>ll;
                s2>>cc;
                ll=ll-ls+ld;
                cc=cc-cs+cd;
                stringstream ss;
                ss<<ll<<","<<cc<<"]";
                temp=temp+ss.str();
                c="";l="";ll=0;cc=0;
            }
            i=i+1;
        }
        else
        {
            temp=temp+ch[i];
            i=i+1;
        }
    }
    edit(ld,cd,temp);
}

//rendre la cellule donnee par l et c la cellule active
void Tableur::active(int l, int c)
{
    string ch;
    ch=rechercheF(l,c);
    if (ch=="")
    {
        edit(l,c,"");
    }
    Lactive=l;
    Cactive=c;
}

void Tableur::get_active(int& l,int& c)const
{
    l=Lactive;
    c=Cactive;
}
